'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var three = require('three');

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

var classCallCheck = _classCallCheck;

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

var createClass = _createClass;

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var _typeof_1 = createCommonjsModule(function (module) {
function _typeof2(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof2 = function _typeof2(obj) { return typeof obj; }; } else { _typeof2 = function _typeof2(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof2(obj); }

function _typeof(obj) {
  if (typeof Symbol === "function" && _typeof2(Symbol.iterator) === "symbol") {
    module.exports = _typeof = function _typeof(obj) {
      return _typeof2(obj);
    };
  } else {
    module.exports = _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : _typeof2(obj);
    };
  }

  return _typeof(obj);
}

module.exports = _typeof;
});

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

var assertThisInitialized = _assertThisInitialized;

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof_1(call) === "object" || typeof call === "function")) {
    return call;
  }

  return assertThisInitialized(self);
}

var possibleConstructorReturn = _possibleConstructorReturn;

var getPrototypeOf = createCommonjsModule(function (module) {
function _getPrototypeOf(o) {
  module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

module.exports = _getPrototypeOf;
});

var setPrototypeOf = createCommonjsModule(function (module) {
function _setPrototypeOf(o, p) {
  module.exports = _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

module.exports = _setPrototypeOf;
});

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) setPrototypeOf(subClass, superClass);
}

var inherits = _inherits;

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

var defineProperty = _defineProperty;

var particle_frag = /* glsl */
"\n\n#include <common>\n#include <uv_pars_fragment>\n#include <map_pars_fragment>\n#include <logdepthbuf_pars_fragment>\n#include <clipping_planes_pars_fragment>\n\nvarying vec4 vColor;\n\nvoid main() {\n\n    #include <clipping_planes_fragment>\n    \n    vec3 outgoingLight = vec3( 0.0 );\n    vec4 diffuseColor = vColor;\n    \n    #include <logdepthbuf_fragment>\n    \n    #ifdef USE_MAP\n    vec4 texelColor = texture2D( map, vUv);\n    diffuseColor *= texelColor;\n    #endif\n\n    outgoingLight = diffuseColor.rgb;\n\n    gl_FragColor = vec4( outgoingLight, diffuseColor.a );\n    \n    #include <tonemapping_fragment>\n\n}\n";
/*
    gl_FragColor = vec4(vUv.x, vUv.y, 1.0, 1.0);

    #ifdef USE_MAP
    vec4 texelColor = texture2D( map, vUv);
    diffuseColor *= texelColor;
    #endif

    outgoingLight = diffuseColor.rgb;

    gl_FragColor = vec4( outgoingLight, diffuseColor.a );
*/

var particle_vert = /* glsl */
"\n\n#include <uv_pars_vertex>\n#include <logdepthbuf_pars_vertex>\n#include <clipping_planes_pars_vertex>\n\nattribute vec3 offset;\nattribute float rotation;\nattribute float size;\nattribute vec4 color;\nattribute float uvTile;\n\nvarying vec4 vColor;\n\n#ifdef UV_TILE\nuniform vec2 tileCount;\n#endif\n\nvoid main() {\n\n    #ifdef UV_TILE\n        vUv = vec2((mod(uvTile, tileCount.y) + uv.x) * (1.0 / tileCount.x), ((tileCount.y - floor(uvTile / tileCount.y) - 1.0) + uv.y) * (1.0 / tileCount.y));\n    #else\n        #include <uv_vertex>\n    #endif\n\t\n\t#ifdef WORLD_SPACE\n\t    vec4 mvPosition = viewMatrix * vec4( offset, 1.0 );\n\t#else\n\t    vec4 mvPosition = modelViewMatrix * vec4( offset, 1.0 );\n\t#endif\n\t\n    vec2 alignedPosition = ( position.xy ) * size;\n    \n    vec2 rotatedPosition;\n    rotatedPosition.x = cos( rotation ) * alignedPosition.x - sin( rotation ) * alignedPosition.y;\n    rotatedPosition.y = sin( rotation ) * alignedPosition.x + cos( rotation ) * alignedPosition.y;\n    \n    mvPosition.xy += rotatedPosition;\n\n\tvColor = color;\n\n\tgl_Position = projectionMatrix * mvPosition;\n\n\t#include <logdepthbuf_vertex>\n\t#include <clipping_planes_vertex>\n\n}\n";
/*
	#ifndef USE_SIZEATTENUATION
		bool isPerspective = ( projectionMatrix[ 2 ][ 3 ] == - 1.0 );
		if ( isPerspective ) computedSize *= - mvPosition.z;
	#endif
 */

var ParticleEmitter =
/*#__PURE__*/
function (_Mesh) {
  inherits(ParticleEmitter, _Mesh);

  function ParticleEmitter(system, parameters) {
    var _this;

    classCallCheck(this, ParticleEmitter);

    _this = possibleConstructorReturn(this, getPrototypeOf(ParticleEmitter).call(this));

    defineProperty(assertThisInitialized(_this), "type", "ParticleEmitter");

    defineProperty(assertThisInitialized(_this), "system", void 0);

    defineProperty(assertThisInitialized(_this), "geometry", void 0);

    defineProperty(assertThisInitialized(_this), "material", void 0);

    defineProperty(assertThisInitialized(_this), "rotationBuffer", void 0);

    defineProperty(assertThisInitialized(_this), "sizeBuffer", void 0);

    defineProperty(assertThisInitialized(_this), "colorBuffer", void 0);

    defineProperty(assertThisInitialized(_this), "offsetBuffer", void 0);

    defineProperty(assertThisInitialized(_this), "tiling", void 0);

    defineProperty(assertThisInitialized(_this), "uvTileBuffer", void 0);

    _this.system = system;
    _this.geometry = new three.InstancedBufferGeometry();
    var float32Array = new Float32Array([-0.5, -0.5, 0, 0, 0, 0.5, -0.5, 0, 1, 0, 0.5, 0.5, 0, 1, 1, -0.5, 0.5, 0, 0, 1]);
    var uniforms = {};
    var defines = {};
    var interleavedBuffer = new three.InterleavedBuffer(float32Array, 5);

    _this.geometry.setIndex([0, 1, 2, 0, 2, 3]);

    _this.geometry.addAttribute('position', new three.InterleavedBufferAttribute(interleavedBuffer, 3, 0, false));

    _this.geometry.addAttribute('uv', new three.InterleavedBufferAttribute(interleavedBuffer, 2, 3, false));

    _this.offsetBuffer = new three.InstancedBufferAttribute(new Float32Array(system.maxParticle * 3), 3);

    _this.offsetBuffer.setDynamic(true);

    _this.geometry.addAttribute('offset', _this.offsetBuffer);

    _this.colorBuffer = new three.InstancedBufferAttribute(new Float32Array(system.maxParticle * 4), 4);

    _this.colorBuffer.setDynamic(true);

    _this.geometry.addAttribute('color', _this.colorBuffer);

    _this.rotationBuffer = new three.InstancedBufferAttribute(new Float32Array(system.maxParticle), 1);

    _this.rotationBuffer.setDynamic(true);

    _this.geometry.addAttribute('rotation', _this.rotationBuffer);

    _this.sizeBuffer = new three.InstancedBufferAttribute(new Float32Array(system.maxParticle), 1);

    _this.sizeBuffer.setDynamic(true);

    _this.geometry.addAttribute('size', _this.sizeBuffer);

    _this.tiling = false;

    if (parameters.texture) {
      defines['USE_MAP'] = '';
      uniforms['map'] = new three.Uniform(parameters.texture); //@ts-ignore

      uniforms['uvTransform'] = new three.Uniform(new three.Matrix3().copy(parameters.texture.matrix));
      var uTileCount = parameters.uTileCount || 1;
      var vTileCount = parameters.vTileCount || 1;
      _this.tiling = uTileCount > 1 || vTileCount > 1;
      _this.system.tileCount = uTileCount * vTileCount;

      if (_this.tiling) {
        _this.uvTileBuffer = new three.InstancedBufferAttribute(new Float32Array(system.maxParticle), 1);

        _this.uvTileBuffer.setDynamic(true);

        _this.geometry.addAttribute('uvTile', _this.uvTileBuffer);

        defines['UV_TILE'] = '';
        uniforms['tileCount'] = new three.Uniform(new three.Vector2(uTileCount, vTileCount));
      }
    }

    if (parameters.worldSpace !== undefined ? parameters.worldSpace : true) {
      defines['WORLD_SPACE'] = '';
    }

    _this.material = new three.ShaderMaterial({
      uniforms: uniforms,
      defines: defines,
      vertexShader: particle_vert,
      fragmentShader: particle_frag,
      transparent: true,
      depthWrite: false,
      blending: parameters.blending || three.AdditiveBlending
    }); // TODO: implement boundingVolume

    _this.frustumCulled = false;
    return _this;
  }

  createClass(ParticleEmitter, [{
    key: "update",
    value: function update() {
      var particles = this.system.particles;
      var particleNum = this.system.particleNum;
      this.geometry.maxInstancedCount = particleNum;

      for (var i = 0; i < particleNum; i++) {
        var particle = particles[i];
        this.offsetBuffer.setXYZ(i, particle.position.x, particle.position.y, particle.position.z);
        this.colorBuffer.setXYZW(i, particle.color.x, particle.color.y, particle.color.z, particle.color.w);
        this.rotationBuffer.setX(i, particle.rotation);
        this.sizeBuffer.setX(i, particle.size);

        if (this.tiling) {
          this.uvTileBuffer.setX(i, particle.uvTile);
        }
      }

      if (particleNum > 0) {
        this.offsetBuffer.updateRange.count = particleNum * 3;
        this.offsetBuffer.needsUpdate = true;
        this.colorBuffer.updateRange.count = particleNum * 4;
        this.colorBuffer.needsUpdate = true;
        this.rotationBuffer.updateRange.count = particleNum;
        this.rotationBuffer.needsUpdate = true;
        this.sizeBuffer.updateRange.count = particleNum;
        this.sizeBuffer.needsUpdate = true;

        if (this.tiling) {
          this.uvTileBuffer.updateRange.count = particleNum;
          this.uvTileBuffer.needsUpdate = true;
        }
      }
    } // extract data from the cache hash
    // remove metadata on each item
    // and return as array

  }, {
    key: "extractFromCache",
    value: function extractFromCache(cache) {
      var values = [];

      for (var key in cache) {
        var data = cache[key];
        delete data.metadata;
        values.push(data);
      }

      return values;
    }
  }, {
    key: "toJSON",
    value: function toJSON(meta) {
      // meta is a string when called from JSON.stringify
      var isRootObject = meta === undefined || typeof meta === 'string';
      var output = {}; // meta is a hash used to collect geometries, materials.
      // not providing it implies that this is the root object
      // being serialized.

      if (isRootObject) {
        // initialize meta obj
        meta = {
          geometries: {},
          materials: {},
          textures: {},
          images: {}
        };
        output.metadata = {
          version: 4.5,
          type: 'Object',
          generator: 'Object3D.toJSON'
        };
      } // standard Object3D serialization


      var object = {};
      object.uuid = this.uuid;
      object.type = this.type;
      if (this.name !== '') object.name = this.name;
      if (this.castShadow === true) object.castShadow = true;
      if (this.receiveShadow === true) object.receiveShadow = true;
      if (this.visible === false) object.visible = false;
      if (this.frustumCulled === false) object.frustumCulled = false;
      if (this.renderOrder !== 0) object.renderOrder = this.renderOrder;
      if (JSON.stringify(this.userData) !== '{}') object.userData = this.userData;
      object.layers = this.layers.mask;
      object.matrix = this.matrix.toArray();
      if (this.matrixAutoUpdate === false) object.matrixAutoUpdate = false; // object specific properties

      if (this.isMesh && this.drawMode !== three.TrianglesDrawMode) object.drawMode = this.drawMode;
      if (this.system !== null) object.ps = this.system.toJSON(meta);

      if (this.children.length > 0) {
        object.children = [];

        for (var i = 0; i < this.children.length; i++) {
          object.children.push(this.children[i].toJSON(meta).object);
        }
      }

      if (isRootObject) {
        var geometries = this.extractFromCache(meta.geometries);
        var materials = this.extractFromCache(meta.materials);
        var textures = this.extractFromCache(meta.textures);
        var images = this.extractFromCache(meta.images);
        if (geometries.length > 0) output.geometries = geometries;
        if (materials.length > 0) output.materials = materials;
        if (textures.length > 0) output.textures = textures;
        if (images.length > 0) output.images = images;
      }

      output.object = object;
      return output;
    }
  }]);

  return ParticleEmitter;
}(three.Mesh);

var Particle = function Particle() {
  classCallCheck(this, Particle);

  defineProperty(this, "startSpeed", 0);

  defineProperty(this, "startColor", new three.Vector4());

  defineProperty(this, "startSize", 1);

  defineProperty(this, "velocity", new three.Vector3());

  defineProperty(this, "age", 0);

  defineProperty(this, "life", 1);

  defineProperty(this, "angularVelocity", void 0);

  defineProperty(this, "position", new three.Vector3());

  defineProperty(this, "rotation", 0);

  defineProperty(this, "size", 1);

  defineProperty(this, "color", new three.Vector4());

  defineProperty(this, "uvTile", 0);
};

var ConstantValue =
/*#__PURE__*/
function () {
  function ConstantValue(value) {
    classCallCheck(this, ConstantValue);

    this.value = value;

    defineProperty(this, "type", void 0);

    this.type = 'value';
  }

  createClass(ConstantValue, [{
    key: "genValue",
    value: function genValue() {
      return this.value;
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        type: "ConstantValue",
        value: this.value
      };
    }
  }], [{
    key: "fromJSON",
    value: function fromJSON(json) {
      return new ConstantValue(json.value);
    }
  }]);

  return ConstantValue;
}();

var IntervalValue =
/*#__PURE__*/
function () {
  function IntervalValue(a, b) {
    classCallCheck(this, IntervalValue);

    this.a = a;
    this.b = b;

    defineProperty(this, "type", void 0);

    this.type = "value";
  }

  createClass(IntervalValue, [{
    key: "genValue",
    value: function genValue() {
      return three.Math.lerp(this.a, this.b, Math.random());
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        type: "IntervalValue",
        a: this.a,
        b: this.b
      };
    }
  }], [{
    key: "fromJSON",
    value: function fromJSON(json) {
      return new IntervalValue(json.a, json.b);
    }
  }]);

  return IntervalValue;
}();

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

var arrayWithHoles = _arrayWithHoles;

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

var iterableToArrayLimit = _iterableToArrayLimit;

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

var nonIterableRest = _nonIterableRest;

function _slicedToArray(arr, i) {
  return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || nonIterableRest();
}

var slicedToArray = _slicedToArray;

var PiecewiseFunction =
/*#__PURE__*/
function () {
  function PiecewiseFunction() {
    classCallCheck(this, PiecewiseFunction);

    defineProperty(this, "functions", void 0);

    this.functions = new Array();
  }

  createClass(PiecewiseFunction, [{
    key: "findFunction",
    value: function findFunction(t) {
      var mid = 0;
      var left = 0,
          right = this.functions.length - 1;

      while (left + 1 < right) {
        mid = (left + right) / 2;
        if (t < this.getStartX(mid)) right = mid - 1;else if (t > this.getEndX(mid)) left = mid + 1;else return mid;
      }

      for (var i = left; i <= right; i++) {
        if (t >= this.functions[i][1] && t <= this.getEndX(i)) return i;
      }

      return -1;
    }
  }, {
    key: "getStartX",
    value: function getStartX(index) {
      return this.functions[index][1];
    }
  }, {
    key: "setStartX",
    value: function setStartX(index, x) {
      if (index > 0) this.functions[index][1] = x;
    }
  }, {
    key: "getEndX",
    value: function getEndX(index) {
      if (index + 1 < this.functions.length) return this.functions[index + 1][1];
      return 1;
    }
  }, {
    key: "setEndX",
    value: function setEndX(index, x) {
      if (index + 1 < this.functions.length) this.functions[index + 1][1] = x;
    }
  }, {
    key: "getFunction",
    value: function getFunction(index) {
      return this.functions[index][0];
    }
  }, {
    key: "setFunction",
    value: function setFunction(index, func) {
      this.functions[index][0] = func;
    }
  }, {
    key: "numOfFunctions",
    get: function get() {
      return this.functions.length;
    }
  }]);

  return PiecewiseFunction;
}();

var Bezier =
/*#__PURE__*/
function () {
  function Bezier(p1, p2, p3, p4) {
    classCallCheck(this, Bezier);

    defineProperty(this, "p", void 0);

    this.p = [p1, p2, p3, p4];
  }

  createClass(Bezier, [{
    key: "genValue",
    value: function genValue(t) {
      var t2 = t * t;
      var t3 = t * t * t;
      var mt = 1 - t;
      var mt2 = mt * mt;
      var mt3 = mt2 * mt;
      return this.p[0] * mt3 + this.p[1] * mt2 * t * 3 + this.p[2] * mt * t2 * 3 + this.p[3] * t3;
    }
  }, {
    key: "derive",
    value: function derive(points) {
      var dpoints = [];

      for (var p = points, d = p.length, c = d - 1; d > 1; d--, c--) {
        var list = [];

        for (var j = 0, dpt; j < c; j++) {
          dpt = c * (p[j + 1] - p[j]);
          list.push(dpt);
        }

        dpoints.push(list);
        p = list;
      }

      return dpoints;
    }
  }, {
    key: "derivative",
    value: function derivative(t) {
      var p = this.derive(this.p)[0];
      var mt = 1 - t;
      var a = mt * mt;
      var b = mt * t * 2;
      var c = t * t;
      return a * p[0] + b * p[1] + c * p[2];
      return a * (p[1] - p[0]) * 3 + b * (p[2] - p[1]) * 3 + c * (p[3] - p[2]) * 3;
    } // derivative(0) = (p[1] - p[0]) * 3
    // derivative(1) = (p[3] - p[2]) * 3

  }, {
    key: "controlCurve",
    value: function controlCurve(d0, d1) {
      this.p[1] = d0 / 3 + this.p[0];
      this.p[2] = this.p[3] - d1 / 3;
    }
  }, {
    key: "hull",
    value: function hull(t) {
      var p = this.p;
      var _p = [],
          pt,
          q = [],
          idx = 0,
          i = 0,
          l = 0;
      q[idx++] = p[0];
      q[idx++] = p[1];
      q[idx++] = p[2];
      q[idx++] = p[3]; // we lerp between all points at each iteration, until we have 1 point left.

      while (p.length > 1) {
        _p = [];

        for (i = 0, l = p.length - 1; i < l; i++) {
          pt = t * p[i] + (1 - t) * p[i + 1];
          q[idx++] = pt;

          _p.push(pt);
        }

        p = _p;
      }

      return q;
    }
  }, {
    key: "split",
    value: function split(t) {
      // no shortcut: use "de Casteljau" iteration.
      var q = this.hull(t);
      var result = {
        left: new Bezier(q[0], q[4], q[7], q[9]),
        right: new Bezier(q[9], q[8], q[6], q[3]),
        span: q
      };
      return result;
    }
  }, {
    key: "clone",
    value: function clone() {
      return new Bezier(this.p[0], this.p[1], this.p[2], this.p[3]);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        p0: this.p[0],
        p1: this.p[1],
        p2: this.p[2],
        p3: this.p[3]
      };
    }
  }], [{
    key: "fromJSON",
    value: function fromJSON(json) {
      return new Bezier(json.p0, json.p1, json.p2, json.p3);
    }
  }]);

  return Bezier;
}();

var PiecewiseBezier =
/*#__PURE__*/
function (_PiecewiseFunction) {
  inherits(PiecewiseBezier, _PiecewiseFunction);

  // default linear bezier
  function PiecewiseBezier() {
    var _this;

    var curves = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [[new Bezier(0, 1.0 / 3, 1.0 / 3 * 2, 1), 0]];

    classCallCheck(this, PiecewiseBezier);

    _this = possibleConstructorReturn(this, getPrototypeOf(PiecewiseBezier).call(this));

    defineProperty(assertThisInitialized(_this), "type", void 0);

    _this.type = "function";
    _this.functions = curves;
    return _this;
  }

  createClass(PiecewiseBezier, [{
    key: "genValue",
    value: function genValue() {
      var t = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
      var index = this.findFunction(t);

      if (index === -1) {
        console.error(t);
        return 0;
      }

      return this.functions[index][0].genValue((t - this.getStartX(index)) / (this.getEndX(index) - this.getStartX(index)));
    }
  }, {
    key: "toSVG",
    value: function toSVG(length, segments) {
      if (segments < 1) return "";
      var result = ["M", 0, this.functions[0][0].p[0]].join(" ");

      for (var i = 1.0 / segments; i <= 1; i += 1.0 / segments) {
        result = [result, "L", i * length, this.genValue(i)].join(" ");
      }

      return result;
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        type: "PiecewiseBezier",
        functions: this.functions.map(function (_ref) {
          var _ref2 = slicedToArray(_ref, 2),
              bezier = _ref2[0],
              start = _ref2[1];

          return {
            "function": bezier.toJSON(),
            start: start
          };
        })
      };
    }
  }], [{
    key: "fromJSON",
    value: function fromJSON(json) {
      return new PiecewiseBezier(json.functions.map(function (piecewiseFunction) {
        return [Bezier.fromJSON(piecewiseFunction["function"]), piecewiseFunction.start];
      }));
    }
  }]);

  return PiecewiseBezier;
}(PiecewiseFunction);

function ValueGeneratorFromJSON(json) {
  switch (json.type) {
    case 'ConstantValue':
      return ConstantValue.fromJSON(json);

    case 'IntervalValue':
      return IntervalValue.fromJSON(json);

    case 'PiecewiseBezier':
      return PiecewiseBezier.fromJSON(json);

    default:
      return new ConstantValue(0);
  }
}

var ColorToJSON = function ColorToJSON(color) {
  return {
    r: color.x,
    g: color.y,
    b: color.z,
    a: color.w
  };
};
var JSONToColor = function JSONToColor(json) {
  return new three.Vector4(json.r, json.g, json.b, json.a);
};

var RandomColor =
/*#__PURE__*/
function () {
  function RandomColor(a, b) {
    classCallCheck(this, RandomColor);

    this.a = a;
    this.b = b;

    defineProperty(this, "type", void 0);

    this.type = "value";
  }

  createClass(RandomColor, [{
    key: "genColor",
    value: function genColor(color) {
      var rand = Math.random();
      return color.copy(this.a).lerp(this.b, rand);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        type: "RandomColor",
        a: ColorToJSON(this.a),
        b: ColorToJSON(this.b)
      };
    }
  }], [{
    key: "fromJSON",
    value: function fromJSON(json) {
      return new RandomColor(JSONToColor(json.a), JSONToColor(json.b));
    }
  }]);

  return RandomColor;
}();

var ColorRange =
/*#__PURE__*/
function () {
  function ColorRange(a, b) {
    classCallCheck(this, ColorRange);

    this.a = a;
    this.b = b;

    defineProperty(this, "type", void 0);

    this.type = "function";
  }

  createClass(ColorRange, [{
    key: "genColor",
    value: function genColor(color, t) {
      return color.copy(this.a).lerp(this.b, t);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        type: "ColorRange",
        a: ColorToJSON(this.a),
        b: ColorToJSON(this.b)
      };
    }
  }], [{
    key: "fromJSON",
    value: function fromJSON(json) {
      return new ColorRange(JSONToColor(json.a), JSONToColor(json.b));
    }
  }]);

  return ColorRange;
}();

var ConstantColor =
/*#__PURE__*/
function () {
  function ConstantColor(color) {
    classCallCheck(this, ConstantColor);

    this.color = color;

    defineProperty(this, "type", void 0);

    this.type = 'value';
  }

  createClass(ConstantColor, [{
    key: "genColor",
    value: function genColor(color) {
      return color.copy(this.color);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        type: "ConstantColor",
        color: ColorToJSON(this.color)
      };
    }
  }], [{
    key: "fromJSON",
    value: function fromJSON(json) {
      return new ConstantColor(JSONToColor(json.color));
    }
  }]);

  return ConstantColor;
}();
function ColorGeneratorFromJSON(json) {
  switch (json.type) {
    case 'ConstantColor':
      return ConstantColor.fromJSON(json);

    case 'ColorRange':
      return ColorRange.fromJSON(json);

    case 'RandomColor':
      return RandomColor.fromJSON(json);

    default:
      return new ConstantColor(new three.Vector4(1, 1, 1, 1));
  }
}

var ColorOverLife =
/*#__PURE__*/
function () {
  function ColorOverLife(func) {
    classCallCheck(this, ColorOverLife);

    this.func = func;
  }

  createClass(ColorOverLife, [{
    key: "initialize",
    value: function initialize(particle) {}
  }, {
    key: "update",
    value: function update(particle, delta) {
      this.func.genColor(particle.color, particle.age / particle.life).dot(particle.startColor);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        type: 'ColorOverLife',
        func: this.func.toJSON()
      };
    }
  }]);

  return ColorOverLife;
}();

var RotationOverLife =
/*#__PURE__*/
function () {
  function RotationOverLife(angularVelocityFunc) {
    classCallCheck(this, RotationOverLife);

    this.angularVelocityFunc = angularVelocityFunc;
  }

  createClass(RotationOverLife, [{
    key: "initialize",
    value: function initialize(particle) {
      if (this.angularVelocityFunc.type === 'value') {
        particle.angularVelocity = this.angularVelocityFunc.genValue();
      } else {
        particle.angularVelocity = 0;
      }
    }
  }, {
    key: "update",
    value: function update(particle, delta) {
      if (this.angularVelocityFunc.type === 'value') {
        particle.rotation += delta * particle.angularVelocity;
      } else {
        particle.rotation += delta * this.angularVelocityFunc.genValue(particle.age / particle.life);
      }
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        type: 'RotationOverLife',
        func: this.angularVelocityFunc.toJSON()
      };
    }
  }]);

  return RotationOverLife;
}();

var SizeOverLife =
/*#__PURE__*/
function () {
  createClass(SizeOverLife, [{
    key: "initialize",
    value: function initialize(particle) {}
  }]);

  function SizeOverLife(func) {
    classCallCheck(this, SizeOverLife);

    this.func = func;
  }

  createClass(SizeOverLife, [{
    key: "update",
    value: function update(particle) {
      particle.size = particle.startSize * this.func.genValue(particle.age / particle.life);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        type: 'SizeOverLife',
        func: this.func.toJSON()
      };
    }
  }]);

  return SizeOverLife;
}();

function BehaviorFromJSON(json) {
  switch (json.type) {
    case 'ColorOverLife':
      return new ColorOverLife(ColorGeneratorFromJSON(json.func));

    case 'RotationOverLife':
      return new RotationOverLife(ValueGeneratorFromJSON(json.func));

    case 'SizeOverLife':
      return new SizeOverLife(ValueGeneratorFromJSON(json.func));

    default:
      return new ColorOverLife(new ColorRange(new three.Vector4(1, 1, 1, 1), new three.Vector4(1, 1, 1, 1)));
  }
}

var ConeEmitter =
/*#__PURE__*/
function () {
  // [0, Math.PI * 2]
  // [0, Math.PI / 2]
  function ConeEmitter() {
    var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, ConeEmitter);

    defineProperty(this, "radius", void 0);

    defineProperty(this, "arc", void 0);

    defineProperty(this, "thickness", void 0);

    defineProperty(this, "angle", void 0);

    this.radius = parameters.radius || 10;
    this.arc = parameters.arc || 2.0 * Math.PI;
    this.thickness = parameters.thickness || 1;
    this.angle = parameters.angle || Math.PI / 6;
  }

  createClass(ConeEmitter, [{
    key: "initialize",
    value: function initialize(p) {
      var u = Math.random();

      var rand = three.Math.lerp(1 - this.thickness, 1, Math.random());

      var theta = u * this.arc;
      var r = Math.sqrt(rand);
      var sinTheta = Math.sin(theta);
      var cosTheta = Math.cos(theta);
      p.position.x = r * cosTheta;
      p.position.y = r * sinTheta;
      p.position.z = 0;
      var angle = this.angle * r;
      p.velocity.set(0, 0, Math.cos(angle)).addScaledVector(p.position, Math.sin(angle)).multiplyScalar(p.startSpeed); //const v = Math.random();

      p.position.multiplyScalar(this.radius);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        type: "cone",
        radius: this.radius,
        arc: this.arc,
        thickness: this.thickness,
        angle: this.angle
      };
    }
  }]);

  return ConeEmitter;
}();

var SphereEmitter =
/*#__PURE__*/
function () {
  //[0, 1]
  function SphereEmitter() {
    var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, SphereEmitter);

    defineProperty(this, "radius", void 0);

    defineProperty(this, "arc", void 0);

    defineProperty(this, "thickness", void 0);

    this.radius = parameters.radius || 10;
    this.arc = parameters.arc || 2.0 * Math.PI;
    this.thickness = parameters.thickness || 1;
  }

  createClass(SphereEmitter, [{
    key: "initialize",
    value: function initialize(p) {
      var u = Math.random();
      var v = Math.random();

      var rand = three.Math.lerp(1 - this.thickness, 1, Math.random());

      var theta = u * this.arc;
      var phi = Math.acos(2.0 * v - 1.0);
      var r = Math.cbrt(rand);
      var sinTheta = Math.sin(theta);
      var cosTheta = Math.cos(theta);
      var sinPhi = Math.sin(phi);
      var cosPhi = Math.cos(phi);
      p.position.x = r * sinPhi * cosTheta;
      p.position.y = r * sinPhi * sinTheta;
      p.position.z = r * cosPhi;
      p.velocity.setScalar(0).addScaledVector(p.position, p.startSpeed);
      p.position.multiplyScalar(this.radius);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        type: "sphere",
        radius: this.radius,
        arc: this.arc,
        thickness: this.thickness
      };
    }
  }]);

  return SphereEmitter;
}();

var ParticleSystem =
/*#__PURE__*/
function () {
  createClass(ParticleSystem, [{
    key: "texture",
    // parameters
    // runtime data
    get: function get() {
      return this.emitter.material.uniforms.map.value;
    },
    set: function set(texture) {
      this.emitter.material.uniforms.map.value = texture;
    }
  }, {
    key: "uTileCount",
    get: function get() {
      return this.emitter.material.uniforms.tileCount.value.x;
    },
    set: function set(u) {
      this.emitter.material.uniforms.tileCount.value.x = u;
    }
  }, {
    key: "vTileCount",
    get: function get() {
      return this.emitter.material.uniforms.tileCount.value.y;
    },
    set: function set(v) {
      this.emitter.material.uniforms.tileCount.value.y = v;
    }
  }, {
    key: "blending",
    get: function get() {
      return this.emitter.material.blending;
    },
    set: function set(blending) {
      this.emitter.material.blending = blending;
    }
  }]);

  function ParticleSystem() {
    var parameters = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, ParticleSystem);

    defineProperty(this, "autoDestroy", void 0);

    defineProperty(this, "looping", void 0);

    defineProperty(this, "duration", void 0);

    defineProperty(this, "maxParticle", void 0);

    defineProperty(this, "startLife", void 0);

    defineProperty(this, "startSpeed", void 0);

    defineProperty(this, "startRotation", void 0);

    defineProperty(this, "startSize", void 0);

    defineProperty(this, "startColor", void 0);

    defineProperty(this, "startTileIndex", void 0);

    defineProperty(this, "emissionOverTime", void 0);

    defineProperty(this, "emissionOverDistance", void 0);

    defineProperty(this, "tileCount", 1);

    defineProperty(this, "worldSpace", void 0);

    defineProperty(this, "particleNum", void 0);

    defineProperty(this, "time", void 0);

    defineProperty(this, "waitEmiting", void 0);

    defineProperty(this, "emitEnded", void 0);

    defineProperty(this, "markForDestroy", void 0);

    defineProperty(this, "behaviors", void 0);

    defineProperty(this, "particles", void 0);

    defineProperty(this, "emitterShape", void 0);

    defineProperty(this, "emitter", void 0);

    defineProperty(this, "normalMatrix", new three.Matrix3());

    this.autoDestroy = parameters.autoDestroy || false;
    this.duration = parameters.duration || 1;
    this.maxParticle = parameters.maxParticle || 100;
    this.looping = parameters.looping === undefined ? true : parameters.looping;
    this.startLife = parameters.startLife || new ConstantValue(5);
    this.startSpeed = parameters.startSpeed || new ConstantValue(0);
    this.startRotation = parameters.startRotation || new ConstantValue(0);
    this.startSize = parameters.startSize || new ConstantValue(1);
    this.startColor = parameters.startColor || new ConstantColor(new three.Vector4(1, 1, 1, 1));
    this.emissionOverTime = parameters.emissionOverTime || new ConstantValue(10);
    this.emissionOverDistance = parameters.emissionOverDistance || new ConstantValue(0);
    this.emitterShape = parameters.shape || new SphereEmitter();
    this.behaviors = parameters.behaviors || new Array();
    if (parameters.worldSpace === undefined) parameters.worldSpace = true;
    this.worldSpace = parameters.worldSpace;
    this.particles = new Array();
    this.startTileIndex = parameters.startTileIndex || 0;
    this.emitter = new ParticleEmitter(this, parameters);
    this.particleNum = 0;
    this.time = 0;
    this.waitEmiting = 0;
    this.emitEnded = false;
    this.markForDestroy = false;
  }

  createClass(ParticleSystem, [{
    key: "spawn",
    value: function spawn() {
      while (this.particleNum >= this.particles.length) {
        this.particles.push(new Particle());
      }

      this.particleNum++;
      var particle = this.particles[this.particleNum - 1];
      this.startColor.genColor(particle.startColor, this.time);
      particle.color.copy(particle.startColor);
      particle.startSpeed = this.startSpeed.genValue(this.time);
      particle.life = this.startLife.genValue(this.time);
      particle.age = 0;
      particle.rotation = this.startRotation.genValue(this.time);
      particle.startSize = particle.size = this.startSize.genValue(this.time);
      particle.uvTile = this.startTileIndex;
      this.emitterShape.initialize(particle);

      if (this.worldSpace) {
        particle.position.applyMatrix4(this.emitter.matrixWorld);
        particle.velocity.applyMatrix3(this.normalMatrix);
      }

      for (var j = 0; j < this.behaviors.length; j++) {
        this.behaviors[j].initialize(particle);
      }
    }
  }, {
    key: "endEmit",
    value: function endEmit() {
      this.emitEnded = true;

      if (this.autoDestroy) {
        this.markForDestroy = true;
      }
    }
  }, {
    key: "update",
    value: function update(delta) {
      if (delta > 0.1) delta = 0.1;

      if (this.emitEnded && this.particleNum === 0) {
        if (this.markForDestroy && this.emitter.parent) this.emitter.parent.remove(this.emitter);
        return;
      }

      if (this.time > this.duration) {
        if (this.looping) {
          this.time -= this.duration;
        } else {
          if (!this.emitEnded) {
            this.endEmit();
          }
        }
      }

      this.normalMatrix.getNormalMatrix(this.emitter.matrixWorld); // particle die

      for (var i = 0; i < this.particleNum; i++) {
        var particle = this.particles[i];

        if (particle.age >= particle.life) {
          this.particles[i] = this.particles[this.particleNum - 1];
          this.particles[this.particleNum - 1] = particle;
          this.particleNum--;
          i--;
        }
      } // spawn


      while (this.waitEmiting > 0 && this.particleNum < this.maxParticle && !this.emitEnded) {
        this.spawn();
        this.waitEmiting--;
      }

      for (var _i = 0; _i < this.particleNum; _i++) {
        var _particle = this.particles[_i];

        for (var j = 0; j < this.behaviors.length; j++) {
          this.behaviors[j].update(_particle, delta);
        }

        _particle.position.addScaledVector(_particle.velocity, delta);

        _particle.age += delta;
      } //console.log(this.particleNum + " " + this.particles.length);


      this.emitter.update();

      if (!this.emitEnded) {
        this.waitEmiting += delta * this.emissionOverTime.genValue(this.time);
      }

      this.time += delta;
    }
  }, {
    key: "toJSON",
    value: function toJSON(meta) {
      return {
        autoDestroy: this.autoDestroy,
        looping: this.looping,
        duration: this.duration,
        maxParticle: this.maxParticle,
        shape: this.emitterShape.toJSON(),
        startLife: this.startLife.toJSON(),
        startSpeed: this.startSpeed.toJSON(),
        startRotation: this.startRotation.toJSON(),
        startSize: this.startSize.toJSON(),
        startColor: this.startColor.toJSON(),
        emissionOverTime: this.emissionOverTime.toJSON(),
        emissionOverDistance: this.emissionOverDistance.toJSON(),
        texture: this.texture.toJSON(meta).uuid,
        startTileIndex: this.startTileIndex,
        uTileCount: this.uTileCount,
        vTileCount: this.vTileCount,
        blending: this.blending,
        behaviors: this.behaviors.map(function (behavior) {
          return behavior.toJSON();
        }),
        worldSpace: this.worldSpace
      };
    }
  }, {
    key: "addBehavior",
    value: function addBehavior(behavior) {
      this.behaviors.push(behavior);
    }
  }], [{
    key: "fromJSON",
    value: function fromJSON(json, textures) {
      var shape;

      switch (json.shape.type) {
        case 'cone':
          shape = new ConeEmitter(json.shape);
          break;

        /*case 'donut':
            shape = new DonutEmitter(json.shape);
            break;
        case 'point':
            shape = new PointEmitter(json.shape);
            break;*/

        case 'sphere':
          shape = new SphereEmitter(json.shape);
          break;

        default:
          shape = new SphereEmitter(json.shape);
          break;
      }

      return new ParticleSystem({
        autoDestroy: json.autoDestroy,
        looping: json.looping,
        duration: json.duration,
        maxParticle: json.maxParticle,
        shape: shape,
        startLife: ValueGeneratorFromJSON(json.startLife),
        startSpeed: ValueGeneratorFromJSON(json.startSpeed),
        startRotation: ValueGeneratorFromJSON(json.startRotation),
        startSize: ValueGeneratorFromJSON(json.startSize),
        startColor: ColorGeneratorFromJSON(json.startColor),
        emissionOverTime: ValueGeneratorFromJSON(json.emissionOverTime),
        emissionOverDistance: ValueGeneratorFromJSON(json.emissionOverDistance),
        texture: textures[json.texture],
        startTileIndex: json.startTileIndex,
        uTileCount: json.uTileCount,
        vTileCount: json.vTileCount,
        blending: json.blending,
        behaviors: json.behaviors.map(function (behavior) {
          return BehaviorFromJSON(behavior);
        }),
        worldSpace: json.worldSpace
      });
    }
  }]);

  return ParticleSystem;
}();

var TEXTURE_MAPPING = {
  UVMapping: three.UVMapping,
  CubeReflectionMapping: three.CubeReflectionMapping,
  CubeRefractionMapping: three.CubeRefractionMapping,
  EquirectangularReflectionMapping: three.EquirectangularReflectionMapping,
  EquirectangularRefractionMapping: three.EquirectangularRefractionMapping,
  SphericalReflectionMapping: three.SphericalReflectionMapping,
  CubeUVReflectionMapping: three.CubeUVReflectionMapping,
  CubeUVRefractionMapping: three.CubeUVRefractionMapping
};
var TEXTURE_WRAPPING = {
  RepeatWrapping: three.RepeatWrapping,
  ClampToEdgeWrapping: three.ClampToEdgeWrapping,
  MirroredRepeatWrapping: three.MirroredRepeatWrapping
};
var TEXTURE_FILTER = {
  NearestFilter: three.NearestFilter,
  NearestMipmapNearestFilter: three.NearestMipMapNearestFilter,
  NearestMipmapLinearFilter: three.NearestMipMapLinearFilter,
  LinearFilter: three.LinearFilter,
  LinearMipmapNearestFilter: three.LinearMipMapNearestFilter,
  LinearMipmapLinearFilter: three.LinearMipMapLinearFilter
};
var QuarksLoader =
/*#__PURE__*/
function () {
  function QuarksLoader(manager) {
    classCallCheck(this, QuarksLoader);

    defineProperty(this, "manager", void 0);

    defineProperty(this, "crossOrigin", "anonymous");

    defineProperty(this, "path", void 0);

    defineProperty(this, "resourcePath", void 0);

    this.manager = manager !== undefined ? manager : three.DefaultLoadingManager;
    this.resourcePath = '';
  }

  createClass(QuarksLoader, [{
    key: "setPath",
    value: function setPath(value) {
      this.path = value;
      return this;
    }
  }, {
    key: "setResourcePath",
    value: function setResourcePath(value) {
      this.resourcePath = value;
      return this;
    }
  }, {
    key: "setCrossOrigin",
    value: function setCrossOrigin(value) {
      this.crossOrigin = value;
      return this;
    }
  }, {
    key: "load",
    value: function load(url, onLoad, onProgress, onError) {
      var scope = this;
      var path = this.path === undefined ? three.LoaderUtils.extractUrlBase(url) : this.path;
      this.resourcePath = this.resourcePath || path;
      var loader = new three.FileLoader(scope.manager);
      if (this.path) loader.setPath(this.path);
      loader.load(url, function (text) {
        var json = null;

        try {
          json = JSON.parse(text);
        } catch (error) {
          if (onError !== undefined) onError(error);
          console.error('THREE:ObjectLoader: Can\'t parse ' + url + '.', error.message);
          return;
        }

        var metadata = json.metadata;

        if (metadata === undefined || metadata.type === undefined || metadata.type.toLowerCase() === 'geometry') {
          console.error('THREE.ObjectLoader: Can\'t load ' + url);
          return;
        }

        scope.parse(json, onLoad);
      }, onProgress, onError);
    }
  }, {
    key: "loadImage",
    value: function loadImage(loader, url) {
      var scope = this;
      scope.manager.itemStart(url);
      return loader.load(url, function () {
        scope.manager.itemEnd(url);
      }, undefined, function () {
        scope.manager.itemError(url);
        scope.manager.itemEnd(url);
      });
    }
  }, {
    key: "parseImages",
    value: function parseImages(json, onLoad) {
      var scope = this;
      var images = {};

      if (json !== undefined && json.length > 0) {
        var manager = new three.LoadingManager(onLoad);
        var loader = new three.ImageLoader(manager);
        loader.setCrossOrigin(this.crossOrigin);

        for (var i = 0, il = json.length; i < il; i++) {
          var image = json[i];
          var url = image.url;

          if (Array.isArray(url)) {
            // load array of images e.g CubeTexture
            images[image.uuid] = [];

            for (var j = 0, jl = url.length; j < jl; j++) {
              var currentUrl = url[j];
              var path = /^(\/\/)|([a-z]+:(\/\/)?)/i.test(currentUrl) ? currentUrl : scope.resourcePath + currentUrl;
              images[image.uuid].push(this.loadImage(loader, path));
            }
          } else {
            // load single image
            var path = /^(\/\/)|([a-z]+:(\/\/)?)/i.test(image.url) ? image.url : scope.resourcePath + image.url;
            images[image.uuid] = this.loadImage(loader, path);
          }
        }
      }

      return images;
    }
  }, {
    key: "parseTextures",
    value: function parseTextures(json, images) {
      function parseConstant(value, type) {
        if (typeof value === 'number') return value;
        console.warn('THREE.ObjectLoader.parseTexture: Constant should be in numeric form.', value);
        return type[value];
      }

      var textures = {};

      if (json !== undefined) {
        for (var i = 0, l = json.length; i < l; i++) {
          var data = json[i];

          if (data.image === undefined) {
            console.warn('THREE.ObjectLoader: No "image" specified for', data.uuid);
          }

          if (images[data.image] === undefined) {
            console.warn('THREE.ObjectLoader: Undefined image', data.image);
          }

          var texture;

          if (Array.isArray(images[data.image])) {
            texture = new three.CubeTexture(images[data.image]);
          } else {
            texture = new three.Texture(images[data.image]);
          }

          texture.needsUpdate = true;
          texture.uuid = data.uuid;
          if (data.name !== undefined) texture.name = data.name;
          if (data.mapping !== undefined) texture.mapping = parseConstant(data.mapping, TEXTURE_MAPPING);
          if (data.offset !== undefined) texture.offset.fromArray(data.offset);
          if (data.repeat !== undefined) texture.repeat.fromArray(data.repeat);
          if (data.center !== undefined) texture.center.fromArray(data.center);
          if (data.rotation !== undefined) texture.rotation = data.rotation;

          if (data.wrap !== undefined) {
            texture.wrapS = parseConstant(data.wrap[0], TEXTURE_WRAPPING);
            texture.wrapT = parseConstant(data.wrap[1], TEXTURE_WRAPPING);
          }

          if (data.format !== undefined) texture.format = data.format;
          if (data.type !== undefined) texture.type = data.type;
          if (data.encoding !== undefined) texture.encoding = data.encoding;
          if (data.minFilter !== undefined) texture.minFilter = parseConstant(data.minFilter, TEXTURE_FILTER);
          if (data.magFilter !== undefined) texture.magFilter = parseConstant(data.magFilter, TEXTURE_FILTER);
          if (data.anisotropy !== undefined) texture.anisotropy = data.anisotropy;
          if (data.flipY !== undefined) texture.flipY = data.flipY;
          if (data.premultiplyAlpha !== undefined) texture.premultiplyAlpha = data.premultiplyAlpha;
          if (data.unpackAlignment !== undefined) texture.unpackAlignment = data.unpackAlignment;
          textures[data.uuid] = texture;
        }
      }

      return textures;
    }
  }, {
    key: "parseObject",
    value: function parseObject(data, textures) {
      var object;

      switch (data.type) {
        case 'ParticleEmitter':
          object = ParticleSystem.fromJSON(data.ps, textures).emitter;
          break;

        case 'Group':
          object = new three.Group();
          break;

        default:
          object = new three.Object3D();
      }

      object.uuid = data.uuid;
      if (data.name !== undefined) object.name = data.name;

      if (data.matrix !== undefined) {
        object.matrix.fromArray(data.matrix);
        if (data.matrixAutoUpdate !== undefined) object.matrixAutoUpdate = data.matrixAutoUpdate;
        if (object.matrixAutoUpdate) object.matrix.decompose(object.position, object.quaternion, object.scale);
      } else {
        if (data.position !== undefined) object.position.fromArray(data.position);
        if (data.rotation !== undefined) object.rotation.fromArray(data.rotation);
        if (data.quaternion !== undefined) object.quaternion.fromArray(data.quaternion);
        if (data.scale !== undefined) object.scale.fromArray(data.scale);
      }

      if (data.castShadow !== undefined) object.castShadow = data.castShadow;
      if (data.receiveShadow !== undefined) object.receiveShadow = data.receiveShadow;
      if (data.visible !== undefined) object.visible = data.visible;
      if (data.frustumCulled !== undefined) object.frustumCulled = data.frustumCulled;
      if (data.renderOrder !== undefined) object.renderOrder = data.renderOrder;
      if (data.userData !== undefined) object.userData = data.userData;
      if (data.layers !== undefined) object.layers.mask = data.layers;

      if (data.children !== undefined) {
        var children = data.children;

        for (var i = 0; i < children.length; i++) {
          object.add(this.parseObject(children[i], textures));
        }
      }

      return object;
    }
  }, {
    key: "parse",
    value: function parse(json, onLoad) {
      var images = this.parseImages(json.images, function () {
        if (onLoad !== undefined) onLoad(object);
      });
      var textures = this.parseTextures(json.textures, images);
      var object = this.parseObject(json.object, textures);

      if (json.images === undefined || json.images.length === 0) {
        if (onLoad !== undefined) onLoad(object);
      }

      return object;
    }
  }]);

  return QuarksLoader;
}();

var DonutEmitter =
/*#__PURE__*/
function () {
  function DonutEmitter() {
    classCallCheck(this, DonutEmitter);

    defineProperty(this, "radius", 10);

    defineProperty(this, "arc", 2.0 * Math.PI);

    defineProperty(this, "thickness", 1);

    defineProperty(this, "angle", Math.PI / 6);
  }

  createClass(DonutEmitter, [{
    key: "initialize",
    // [0, Math.PI / 6]
    value: function initialize(p) {
      var u = Math.random();

      var rand = three.Math.lerp(this.thickness, 1, Math.random());

      var theta = u * this.arc;
      var r = Math.sqrt(rand);
      var sinTheta = Math.sin(theta);
      var cosTheta = Math.cos(theta);
      p.position.x = r * cosTheta;
      p.position.y = r * sinTheta;
      p.position.z = 0;
      var angle = this.angle * r;
      p.velocity.set(0, 0, Math.cos(angle)).addScaledVector(p.position, Math.sin(angle)).multiplyScalar(p.startSpeed); //const v = Math.random();

      p.position.multiplyScalar(this.radius);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        type: "donut"
      };
    }
  }]);

  return DonutEmitter;
}();

var PointEmitter =
/*#__PURE__*/
function () {
  function PointEmitter() {
    classCallCheck(this, PointEmitter);
  }

  createClass(PointEmitter, [{
    key: "initialize",
    value: function initialize(p) {
      var u = Math.random();
      var v = Math.random();
      var theta = u * Math.PI * 2;
      var phi = Math.acos(2.0 * v - 1.0);
      var r = Math.cbrt(Math.random());
      var sinTheta = Math.sin(theta);
      var cosTheta = Math.cos(theta);
      var sinPhi = Math.sin(phi);
      var cosPhi = Math.cos(phi);
      p.velocity.x = r * sinPhi * cosTheta;
      p.velocity.y = r * sinPhi * sinTheta;
      p.velocity.z = r * cosPhi;
      p.position.setScalar(0);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        type: 'point'
      };
    }
  }]);

  return PointEmitter;
}();

var Gradient =
/*#__PURE__*/
function (_PiecewiseFunction) {
  inherits(Gradient, _PiecewiseFunction);

  // default linear bezier
  function Gradient() {
    var _this;

    var functions = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [[new ColorRange(new three.Vector4(0, 0, 0, 1), new three.Vector4(1, 1, 1, 1)), 0]];

    classCallCheck(this, Gradient);

    _this = possibleConstructorReturn(this, getPrototypeOf(Gradient).call(this));

    defineProperty(assertThisInitialized(_this), "type", void 0);

    _this.type = "function";
    _this.functions = functions;
    return _this;
  }

  createClass(Gradient, [{
    key: "genColor",
    value: function genColor(color, t) {
      var index = this.findFunction(t);

      if (index === -1) {
        console.error(t);
        return color.copy(this.functions[0][0].a);
      }

      return this.getFunction(index).genColor(color, t);
    }
  }, {
    key: "toJSON",
    value: function toJSON() {
      return {
        type: "Gradient",
        functions: this.functions.map(function (_ref) {
          var _ref2 = slicedToArray(_ref, 2),
              range = _ref2[0],
              start = _ref2[1];

          return {
            "function": range.toJSON(),
            start: start
          };
        })
      };
    }
  }], [{
    key: "fromJSON",
    value: function fromJSON(json) {
      return new Gradient(json.functions.map(function (piecewiseFunction) {
        return [ColorRange.fromJSON(piecewiseFunction["function"]), piecewiseFunction.start];
      }));
    }
  }]);

  return Gradient;
}(PiecewiseFunction);

exports.BehaviorFromJSON = BehaviorFromJSON;
exports.Bezier = Bezier;
exports.ColorGeneratorFromJSON = ColorGeneratorFromJSON;
exports.ColorOverLife = ColorOverLife;
exports.ColorRange = ColorRange;
exports.ConeEmitter = ConeEmitter;
exports.ConstantColor = ConstantColor;
exports.ConstantValue = ConstantValue;
exports.DonutEmitter = DonutEmitter;
exports.Gradient = Gradient;
exports.IntervalValue = IntervalValue;
exports.Particle = Particle;
exports.ParticleEmitter = ParticleEmitter;
exports.ParticleSystem = ParticleSystem;
exports.PiecewiseBezier = PiecewiseBezier;
exports.PiecewiseFunction = PiecewiseFunction;
exports.PointEmitter = PointEmitter;
exports.QuarksLoader = QuarksLoader;
exports.RandomColor = RandomColor;
exports.RotationOverLife = RotationOverLife;
exports.SizeOverLife = SizeOverLife;
exports.SphereEmitter = SphereEmitter;
exports.ValueGeneratorFromJSON = ValueGeneratorFromJSON;
