import { ParticleSystem } from './ParticleSystem';
import { Blending, InstancedBufferGeometry, Mesh, ShaderMaterial, Texture } from 'three';
export interface ParticleRendererParameters {
    texture?: Texture;
    uTileCount?: number;
    vTileCount?: number;
    worldSpace?: boolean;
    blending?: Blending;
}
export declare class ParticleEmitter extends Mesh {
    type: string;
    system: ParticleSystem;
    geometry: InstancedBufferGeometry;
    material: ShaderMaterial;
    private rotationBuffer;
    private sizeBuffer;
    private colorBuffer;
    private offsetBuffer;
    private tiling;
    private uvTileBuffer?;
    constructor(system: ParticleSystem, parameters: ParticleRendererParameters);
    update(): void;
    extractFromCache(cache: any): any[];
    toJSON(meta?: {
        geometries: any;
        materials: any;
        textures: any;
        images: any;
    }): any;
}
